# Supported Model Formats

By leveraging existing third-party model servers, we support a number of standard ML model formats out-of-the box, with more to follow. Currently supported model types:

- [LightGBM](lightgbm.md)
- [ONNX](onnx.md)
- [PyTorch ScriptModule](pytorch.md)
- [scikit-learn](sklearn.md)
- [TensorFlow](tensorflow.md)
- [XGBoost](xgboost.md)

| Model Type | Framework    | Supported via ServingRuntime |
| ---------- | ------------ | ---------------------------- |
| lightgbm   | LightGBM     | MLServer (python)            |
| onnx       | ONNX         | Triton (C++)                 |
| pytorch    | PyTorch      | Triton (C++)                 |
| sklearn    | scikit-learn | MLServer (python)            |
| tensorflow | TensorFlow   | Triton (C++)                 |
| xgboost    | XGBoost      | MLServer (python)            |
| \*         | Custom       | [Custom](../runtimes) (any)  |
